Index: trunk/source/Lib/TLibRenderer/TRenSingleModel.cpp
===================================================================
--- trunk/source/Lib/TLibRenderer/TRenSingleModel.cpp	(revision 1387)
+++ trunk/source/Lib/TLibRenderer/TRenSingleModel.cpp	(revision 1396)
@@ -793,223 +998,47 @@
 }
 
-#ifdef  H_3D_VSO_EARLY_SKIP
-template <BlenMod iBM, Bool bBitInc> template<Bool bSet> __inline RMDist
-TRenSingleModelC<iBM,bBitInc>::xRenderR( Int iStartPosX, Int iStartPosY, Int iWidth, Int iHeight, Int iStride, const Pel* piNewData , Bool bFast)
-#else
-template <BlenMod iBM, Bool bBitInc> template<Bool bSet> __inline RMDist
-TRenSingleModelC<iBM,bBitInc>::xRenderR( Int iStartPosX, Int iStartPosY, Int iWidth, Int iHeight, Int iStride, const Pel* piNewData )
-#endif
-{
-
-  const Int iCurViewPos   = 1;
-  const Int iOtherViewPos = 0;
-
-  m_iCurViewPos      = iCurViewPos;
-  m_iOtherViewPos    = iOtherViewPos;
-
-  m_piNewDepthData   = piNewData;
-  m_iNewDataWidth    = iWidth;
-  m_iStartChangePosX = iStartPosX;
-
-  if ((iWidth == 0) || (iHeight == 0))
-    return 0;
-
-  // Get Data
-  m_ppiCurLUT      = m_appiShiftLut   [iCurViewPos];
-  xSetViewRow      ( iStartPosY);
-
-  // Init Start
-  RMDist iError = 0;
-  Int   iEndChangePos;
-
-  iEndChangePos = m_iStartChangePosX + iWidth - 1;
-
-  for (Int iPosY = iStartPosY; iPosY < iStartPosY + iHeight; iPosY++ )
-  {
-#if H_3D_VSO_EARLY_SKIP
-    if( m_bEarlySkip && bFast )
-    {
-      if ( m_pbHorSkip[iPosY-iStartPosY] )
-      {
-        xIncViewRow();
-        m_piNewDepthData += iStride;
-        continue;
-      }
-    }
-#endif
-    m_bInOcclusion = false;
-
-    Int iLastSPos;
-    Int iStartChangePos       = m_iStartChangePosX;
-    Int iPosXinNewData        = 0;
-    Int iMaxChangedSPos = -1;
-
-    if ( iStartChangePos == 0 ) // Special processing for leftmost depth sample
-    {
-      m_iCurDepth           = m_piNewDepthData[iPosXinNewData];
-      Int iCurSPos          = xShiftNewData(iStartChangePos, iPosXinNewData);
-      m_iLastOccludedSPos   = iCurSPos - 1;
-      m_iLastOccludedSPosFP = xRangeRightR( m_iLastOccludedSPos );
-      xExtrapolateMarginR<bSet>     ( iCurSPos, iStartChangePos, iError );
-
-      iMaxChangedSPos       = std::max( iMaxChangedSPos, (iStartChangePos << m_iShiftPrec) - m_ppiCurLUT[0][ RenModRemoveBitInc( std::max(m_pcInputSamplesRow[iCurViewPos][iStartChangePos].iD, m_piNewDepthData[iPosXinNewData] )) ]);
-      iLastSPos             = iCurSPos;
-      m_iLastDepth          = m_iCurDepth;
-      if ( bSet )
-      {
-        m_pcInputSamplesRow[iCurViewPos][iStartChangePos].iD = m_piNewDepthData[iPosXinNewData];
-      }
-
-
-      iPosXinNewData++;
-      iStartChangePos++;
-    }
-    else
-    {
-      iLastSPos   = xShift(iStartChangePos-1);
-
-      m_iLastDepth = m_pcInputSamplesRow[iCurViewPos][iStartChangePos-1].iD;
-      xInitRenderPartR( iStartChangePos, iLastSPos );
-    }
-
-    //// RENDER NEW DATA
-    Int iCurPosX;
-    for ( iCurPosX = iStartChangePos; iCurPosX <= iEndChangePos; iCurPosX++ )
-    {
-      // Get minimal changed sample position
-
-      iMaxChangedSPos = std::max( iMaxChangedSPos, (iCurPosX << m_iShiftPrec) - m_ppiCurLUT[0][ RenModRemoveBitInc( std::max(m_pcInputSamplesRow[iCurViewPos][iCurPosX].iD, m_piNewDepthData[iPosXinNewData] )) ]);
-      Int iCurSPos    = xShiftNewData(iCurPosX,iPosXinNewData);
-      m_iCurDepth     = m_piNewDepthData[iPosXinNewData];
-      xRenderRangeR<bSet>(iCurSPos, iLastSPos, iCurPosX, iError );
-      iLastSPos      = iCurSPos;
-      m_iLastDepth    = m_iCurDepth;
-
-      if ( bSet )
-      {
-        m_pcInputSamplesRow[iCurViewPos][iCurPosX].iD = m_piNewDepthData[iPosXinNewData];
-      }
-
-      iPosXinNewData++;
-    }
-
-    //// RE-RENDER DATA LEFT TO NEW DATA
-    while ( iCurPosX < m_iWidth )
-    {
-      Int iCurSPos = xShift(iCurPosX);
-
-      m_iCurDepth  = m_pcInputSamplesRow[iCurViewPos][iCurPosX].iD;
-      xRenderRangeR<bSet>( iCurSPos, iLastSPos, iCurPosX, iError );
-
-      if ( iCurSPos > iMaxChangedSPos )
-      {
-          break;
-        }
-      iCurPosX++;
-      iLastSPos    = iCurSPos;
-      m_iLastDepth = m_iCurDepth;
-    }
-
-    xIncViewRow();
-    m_piNewDepthData += iStride;
-  }
-  return iError;
-}
-
-
-template <BlenMod iBM, Bool bBitInc> __inline Void
-TRenSingleModelC<iBM,bBitInc>::xInitRenderPartL(  Int iEndChangePos, Int iLastSPos )
-{
-  const Int iCurViewPos = 0; 
-  // GET MINIMAL OCCLUDED SAMPLE POSITION
-  Int iCurPosX           = iEndChangePos;
-
-
-  if ( ( iCurPosX + 1 < m_iWidth ) && (m_pcInputSamplesRow[iCurViewPos][ iCurPosX + 1].bOccluded ) )
-  {
-    iCurPosX++;
-
-    while ( (iCurPosX + 1 < m_iWidth) &&  (m_pcInputSamplesRow[iCurViewPos][ iCurPosX + 1].bOccluded  )  )
-
-      iCurPosX++;
-
-    if ( iCurPosX + 1 < m_iWidth )
-    {
-      iCurPosX++;
-      m_iLastOccludedSPos = xShift(iCurPosX);
-    }
-    else
-    {
-      m_iLastOccludedSPos = xShift(iCurPosX) + 1;
-    }
-
-    m_iLastOccludedSPosFP = xRoundL( m_iLastOccludedSPos );
+template <BlenMod iBM, Bool bBitInc> template<Bool bL> __inline Void
+TRenSingleModelC<iBM,bBitInc>::xInitRenderPart(  Int iEndChangePos, Int iLastSPos )
+{
+  const Int iCurViewPos = bL ? 0 : 1;   
+  m_iLastOccludedSPos = m_pcInputSamplesRow[iCurViewPos][ xPlus<Int,bL>(iEndChangePos,1) ].aiOccludedPos;  
+  m_bInOcclusion      = xGeQ<Int,bL>( iLastSPos, m_iLastOccludedSPos ); 
+
+  if( m_bInOcclusion )
+  {
+    m_lastRangeStart = xRound<bL>( m_iLastOccludedSPos );  
   }
   else
   {
-    m_iLastOccludedSPos   = iLastSPos+1;
-    m_iLastOccludedSPosFP = xRangeLeftL( m_iLastOccludedSPos );
-  }
-
-  m_bInOcclusion = iLastSPos >= m_iLastOccludedSPos;
+    m_iLastOccludedSPos = iLastSPos; 
+    m_lastRangeStart = xRangeLeft<bL>( iLastSPos );  
+  }
 };
 
-template <BlenMod iBM, Bool bBitInc> __inline Void
-TRenSingleModelC<iBM,bBitInc>::xInitRenderPartR(  Int iStartChangePos, Int iLastSPos )
-{
-    const Int iCurViewPos = 1; 
-  // GET MINIMAL OCCLUDED SAMPLE POSITION
-  Int iCurPosX           = iStartChangePos;
-
-  if ( ( iCurPosX - 1 > -1 ) && (m_pcInputSamplesRow[iCurViewPos][ iCurPosX - 1].bOccluded  ) )
-  {
-    iCurPosX--;
-
-    while ( (iCurPosX - 1 > -1 ) &&  (m_pcInputSamplesRow[iCurViewPos][ iCurPosX - 1].bOccluded  )  )
-      iCurPosX--;
-
-    if ( iCurPosX - 1 > -1 )
-    {
-      iCurPosX--;
-      m_iLastOccludedSPos = xShift(iCurPosX);
-    }
-    else
-    {
-      m_iLastOccludedSPos = xShift(iCurPosX) - 1;
-    }
-    m_iLastOccludedSPosFP = xRoundR( m_iLastOccludedSPos );
+template <BlenMod iBM, Bool bBitInc> template<Bool bL, SetMod bSM> __inline Void
+TRenSingleModelC<iBM,bBitInc>::xRenderShiftedRange(Int iCurSPos, Int iLastSPos, Int iCurPos, RMDist& riError )
+{
+  RM_AOF( (xGeQ<Int,bL>(iLastSPos,iCurSPos)) );
+  Int iDeltaSPos = bL ? iLastSPos - iCurSPos : iCurSPos - iLastSPos;
+
+  m_curRangeStart = xRangeLeft<bL>( iCurSPos ); 
+  if ( iDeltaSPos > m_iGapTolerance )
+  {
+    xFillHole<bL,bSM>( iCurSPos, iLastSPos, iCurPos, riError );
   }
   else
   {
-    m_iLastOccludedSPos   = iLastSPos-1;
-    m_iLastOccludedSPosFP = xRangeRightR( m_iLastOccludedSPos );
-  }
-
-  m_bInOcclusion = iLastSPos <= m_iLastOccludedSPos;
-};
-
-
-template <BlenMod iBM, Bool bBitInc> template<Bool bSet> __inline Void
-TRenSingleModelC<iBM,bBitInc>::xRenderShiftedRangeL(Int iCurSPos, Int iLastSPos, Int iCurPos, RMDist& riError )
-{
-  assert( iCurSPos <= iLastSPos );
-  //assert( iRightSPos < m_iWidth );
-
-  Int iDeltaSPos = iLastSPos - iCurSPos;
-  if ( iDeltaSPos > m_iGapTolerance )
-  {
-    xFillHoleL<bSet>( iCurSPos, iLastSPos, iCurPos, riError );
-  }
-  else
-  {
-    if (iLastSPos < 0 )
+    if (!xGeQ<Int,bL>(iLastSPos, bL ? 0 : ( m_iSampledWidth - 1) ))
+    {
       return;
+    }
 
     RM_AOT( iDeltaSPos    > m_iGapTolerance );
 
     m_iThisDepth = m_iCurDepth;
-    for (Int iFillSPos = std::max(0, xRangeLeftL(iCurSPos) ); iFillSPos <= min(xRangeRightL( iLastSPos ) ,m_iLastOccludedSPosFP-1); iFillSPos++ )
-    {
-      Int iDeltaCurSPos  = (iFillSPos << m_iShiftPrec) - iCurSPos;
+
+    for (Int iFillSPos = xMax<Int,bL>(xZero<bL>(), m_curRangeStart ); xLess<Int,bL>(iFillSPos,m_lastRangeStart); xInc<Int,bL>(iFillSPos))
+    {
+      Int iDeltaCurSPos  = (iFillSPos << m_iShiftPrec) - (bL ? iCurSPos : iLastSPos); 
 
       RM_AOT( iDeltaCurSPos > iDeltaSPos );
@@ -1017,281 +1046,118 @@
       RM_AOT( m_aaiSubPelShiftL[iDeltaSPos][iDeltaCurSPos] == 0xdeaddead);
 
-      xSetShiftedPelL<bSet>( iCurPos, m_aaiSubPelShiftL[iDeltaSPos][iDeltaCurSPos], iFillSPos, REN_IS_FILLED, riError );
+      xSetShiftedPel<bL, bSM>( iCurPos, m_aaiSubPelShiftL[iDeltaSPos][iDeltaCurSPos], iFillSPos, REN_IS_FILLED, riError );
     }
   };
-}
-
-template <BlenMod iBM, Bool bBitInc> template<Bool bSet> __inline Void
-TRenSingleModelC<iBM,bBitInc>::xRenderShiftedRangeR(Int iCurSPos, Int iLastSPos, Int iCurPos, RMDist& riError )
-{
-  assert( iCurSPos >= iLastSPos );
-
-  Int iDeltaSPos = iCurSPos - iLastSPos;
-  if ( iDeltaSPos > m_iGapTolerance )
-  {
-    xFillHoleR<bSet>( iCurSPos, iLastSPos, iCurPos, riError );
+  m_lastRangeStart = m_curRangeStart; 
+}
+
+template <BlenMod iBM, Bool bBitInc> template<Bool bL, SetMod bSM> __inline Void
+TRenSingleModelC<iBM,bBitInc>::xRenderRange(Int iCurSPos, Int iLastSPos, Int iCurPos, RMDist& riError )
+{
+  const Int iCurViewPos = bL ? 0 : 1; 
+
+  if ( bSM == SET_FULL || bSM == SET_SIMP )
+  {
+    m_pcInputSamplesRow[iCurViewPos][ iCurPos ].aiOccludedPos = m_iLastOccludedSPos;
+  }
+
+  if ( xLess<Int,bL>(iCurSPos,m_iLastOccludedSPos ))
+  {
+    m_bInOcclusion      = false;
+    m_iLastOccludedSPos = iCurSPos; 
+    xRenderShiftedRange<bL,bSM>(iCurSPos, iLastSPos, iCurPos, riError );
   }
   else
   {
-    if (iLastSPos > m_iSampledWidth - 1 )
-      return;
-
-    m_iThisDepth = m_iCurDepth;
-    RM_AOT( iDeltaSPos    > m_iGapTolerance );
-    for (Int iFillSPos = max(m_iLastOccludedSPosFP+1, xRangeLeftR(iLastSPos) ); iFillSPos <= min(xRangeRightR( iCurSPos ) ,m_iWidth -1); iFillSPos++ )
-    {
-      Int iDeltaCurSPos  = (iFillSPos << m_iShiftPrec) - iLastSPos;
-
-      RM_AOT( iDeltaCurSPos > iDeltaSPos );
-      RM_AOT( iDeltaCurSPos < 0 );
-      RM_AOT( m_aaiSubPelShiftR[iDeltaSPos][iDeltaCurSPos] == 0xdeaddead);
-
-      xSetShiftedPelR<bSet>( iCurPos, m_aaiSubPelShiftR[iDeltaSPos][iDeltaCurSPos], iFillSPos, REN_IS_FILLED, riError );
-    }
-  };
-}
-
-
-
-template <BlenMod iBM, Bool bBitInc> template<Bool bSet> __inline Void
-TRenSingleModelC<iBM,bBitInc>::xRenderRangeL(Int iCurSPos, Int iLastSPos, Int iCurPos, RMDist& riError )
-{
-  const Int iCurViewPos = 0; 
-  if (  !m_bInOcclusion )
-  {
-    if ( iCurSPos >= iLastSPos )
-    {
-      m_iLastOccludedSPos = iLastSPos;
-
-      Int iRightSPosFP = xRoundL( iLastSPos );
-      if ( ( iRightSPosFP == xRangeRightL(iLastSPos)) && (iRightSPosFP >= 0) )
+    if ( !m_bInOcclusion )
+    {      
+      RM_AOF( (xGeQ<Int,bL>(iLastSPos, m_iLastOccludedSPos)) ); 
+      Int iRightSPosFP = xRound<bL>( iLastSPos );      
+      if ( ( iRightSPosFP == xPlus<Int,bL>(m_lastRangeStart, -1) ) && xGeQ<Int,bL>(iRightSPosFP, xZero<bL>()) )
       {
         m_iThisDepth = m_iLastDepth;
-
-        xSetShiftedPelL<bSet>( iCurPos+1, 0, iRightSPosFP, REN_IS_FILLED, riError );
+        xSetShiftedPel<bL, bSM>( xPlus<Int,bL>(iCurPos,1), bL ? 0 : (1 << m_iShiftPrec), iRightSPosFP, REN_IS_FILLED, riError );
       }
-      m_iLastOccludedSPosFP = iRightSPosFP;
-
-      m_bInOcclusion = true;
-
-      if ( bSet )
-      {
-        m_pcInputSamplesRow[iCurViewPos][ iCurPos ].bOccluded  = true;
-      }
-    }
-    else
-    {
-      if ( bSet )
-      {
-        m_pcInputSamplesRow[iCurViewPos][ iCurPos ].bOccluded  = false;
-      }
-
-      xRenderShiftedRangeL<bSet>(iCurSPos, iLastSPos, iCurPos, riError );
-    }
-  }
-  else
-  {
-    if ( iCurSPos < m_iLastOccludedSPos )
-    {
-      m_bInOcclusion = false;
-      if ( bSet )
-      {
-        m_pcInputSamplesRow[iCurViewPos][ iCurPos ].bOccluded  = false;
-      }
-
-      xRenderShiftedRangeL<bSet>(iCurSPos, iLastSPos, iCurPos, riError );
-    }
-    else
-    {
-      if ( bSet )
-      {
-        m_pcInputSamplesRow[iCurViewPos][ iCurPos ].bOccluded  = true;
-      }
-    }
-  }
-}
-
-template <BlenMod iBM, Bool bBitInc> template<Bool bSet> __inline Void
-TRenSingleModelC<iBM,bBitInc>::xRenderRangeR(Int iCurSPos, Int iLastSPos, Int iCurPos, RMDist& riError )
-{
-  const Int iCurViewPos = 1; 
-  // Find out if current sample is occluded
-  if (  !m_bInOcclusion )
-  {
-    if ( iCurSPos <= iLastSPos )
-    {
-      m_iLastOccludedSPos = iLastSPos;
-
-      Int iLeftSPosFP = xRoundR( iLastSPos );
-      if ( ( iLeftSPosFP == xRangeLeftR(iLastSPos)) && (iLeftSPosFP <= m_iWidth - 1) )
-      {
-        m_iThisDepth = m_iLastDepth;
-        xSetShiftedPelR<bSet>( iCurPos-1,1 << m_iShiftPrec , iLeftSPosFP, REN_IS_FILLED, riError );
-      }
-      m_iLastOccludedSPosFP = iLeftSPosFP;
-
-      m_bInOcclusion = true;
-
-      if ( bSet )
-      {
-        m_pcInputSamplesRow[iCurViewPos][ iCurPos ].bOccluded  = true;
-      }
-    }
-    else
-    {
-      if ( bSet )
-      {
-        m_pcInputSamplesRow[iCurViewPos][ iCurPos ].bOccluded  = false;
-      }
-
-      xRenderShiftedRangeR<bSet>(iCurSPos, iLastSPos, iCurPos, riError );
-    }
-  }
-  else
-  {
-    if ( iCurSPos > m_iLastOccludedSPos )
-    {
-      m_bInOcclusion = false;
-      if ( bSet )
-      {
-        m_pcInputSamplesRow[iCurViewPos][ iCurPos ].bOccluded  = false;
-      }
-
-      xRenderShiftedRangeR<bSet>(iCurSPos, iLastSPos, iCurPos, riError );
-    }
-    else
-    {
-      if ( bSet )
-      {
-        m_pcInputSamplesRow[iCurViewPos][ iCurPos ].bOccluded  = true;
-      }
-    }
-  }
-}
-
-template <BlenMod iBM, Bool bBitInc> template<Bool bSet> __inline Void
-TRenSingleModelC<iBM,bBitInc>::xFillHoleL( Int iCurSPos, Int iLastSPos, Int iCurPos, RMDist& riError )
+      m_lastRangeStart = iRightSPosFP;
+      m_bInOcclusion   = true; 
+    }
+  }
+}
+
+template <BlenMod iBM, Bool bBitInc> template<Bool bL, SetMod bSM> __inline Void
+TRenSingleModelC<iBM,bBitInc>::xFillHole( Int iCurSPos, Int iLastSPos, Int iCurPos, RMDist& riError )
 {
   if (iLastSPos < 0)
+  {
     return;
+  }
 
   Int iStartFillSPos = iCurSPos;
   Int iStartFillPos  = iCurPos;
-  Int iLastPos      = iCurPos + 1;
-
-  Int iStartFillSPosFP = xRangeLeftL(iStartFillSPos);
-
-  if (iStartFillSPosFP == xRoundL(iStartFillSPos))
-  {
-    if ((iStartFillSPosFP >= 0) && (iStartFillSPosFP < m_iLastOccludedSPosFP) )
+  Int iLastPos       = xPlus<Int,bL>( iCurPos,1);
+
+  Int iStartFillSPosFP = m_curRangeStart; 
+  if (iStartFillSPosFP == xRound<bL>(iStartFillSPos))
+  {
+    if ( xGeQ<Int,bL>(iStartFillSPosFP, xZero<bL>())  && xLess<Int,bL>(iStartFillSPosFP, m_lastRangeStart) )
     {
       m_iThisDepth = m_iCurDepth;
-      xSetShiftedPelL<bSet>    ( iStartFillPos, 0, iStartFillSPosFP, REN_IS_FILLED, riError );
+      xSetShiftedPel<bL, bSM>    ( iStartFillPos, bL ? 0 : ( 1 << m_iShiftPrec), iStartFillSPosFP, REN_IS_FILLED, riError );
     }
   }
   else
   {
-    iStartFillSPosFP--;
+    xDec<Int,bL>( iStartFillSPosFP );
   }
 
   m_iThisDepth = m_iLastDepth;
-  for (Int iFillSPos = std::max(iStartFillSPosFP+1,0); iFillSPos <= min(xRangeRightL( iLastSPos ), m_iLastOccludedSPosFP-1 ); iFillSPos++ )
-  {
-    xSetShiftedPelL<bSet>( iLastPos, 0,  iFillSPos, REN_IS_HOLE, riError );
-  }
-}
-
-template <BlenMod iBM, Bool bBitInc> template<Bool bSet> __inline Void
-TRenSingleModelC<iBM,bBitInc>::xFillHoleR( Int iCurSPos, Int iLastSPos, Int iCurPos, RMDist& riError )
-{
-  if (iLastSPos < 0)
-    return;
-
-  Int iStartFillSPos = iCurSPos;
-  Int iEndFillPos    = iCurPos;
-  Int iLastPos       = iCurPos - 1;
-
-  Int iStartFillSPosFP = xRangeRightR(iStartFillSPos);
-
-  if (iStartFillSPosFP == xRoundR(iStartFillSPos))
-  {
-    if ((iStartFillSPosFP < m_iWidth) && (iStartFillSPosFP > m_iLastOccludedSPosFP) )
-    {
-      m_iThisDepth = m_iCurDepth;
-      xSetShiftedPelR<bSet>( iEndFillPos, 1 << m_iShiftPrec , iStartFillSPosFP, REN_IS_FILLED, riError );
-    }
-  }
-  else
-  {
-    iStartFillSPosFP++;
-  }
-
-  m_iThisDepth = m_iLastDepth;
-  for (Int iFillSPos = max(xRangeLeftR( iLastSPos ), m_iLastOccludedSPosFP+1); iFillSPos <= min(iStartFillSPosFP,m_iWidth)-1 ; iFillSPos++ )
-  {
-    xSetShiftedPelR<bSet>( iLastPos, 1 << m_iShiftPrec, iFillSPos, REN_IS_HOLE, riError );
-  }
-}
-
-template <BlenMod iBM, Bool bBitInc> template<Bool bSet> __inline Void
-TRenSingleModelC<iBM,bBitInc>::xExtrapolateMarginL(Int iCurSPos, Int iCurPos, RMDist& riError )
-{
-//  if (iLeftSPos < 0 )
-//    return;
-
-  Int iSPosFullPel = std::max(0,xRangeLeftL(iCurSPos));
+  for (Int iFillSPos = xMax<Int,bL>(xPlus<Int,bL>(iStartFillSPosFP,1),xZero<bL>()); xLess<Int,bL>(iFillSPos, m_lastRangeStart); xInc<Int,bL>(iFillSPos))
+  {
+    xSetShiftedPel<bL, bSM>( iLastPos, bL ? 0 : (1 << m_iShiftPrec),  iFillSPos, REN_IS_HOLE, riError );
+  }
+}
+
+template <BlenMod iBM, Bool bBitInc> template<Bool bL, SetMod bSM> __inline Void
+TRenSingleModelC<iBM,bBitInc>::xExtrapolateMargin(Int iCurSPos, Int iCurPos, RMDist& riError )
+{
+  Int iSPosFullPel = xMax<Int,bL>(xZero<bL>(),m_curRangeStart);
 
   m_iThisDepth = m_iCurDepth;
-  if (iSPosFullPel < m_iWidth)
-  {
-    xSetShiftedPelL<bSet>( iCurPos, 0, iSPosFullPel, REN_IS_FILLED, riError );
-  }
-
-  for (Int iFillSPos = iSPosFullPel +1; iFillSPos < m_iWidth; iFillSPos++ )
-  {
-    xSetShiftedPelL<bSet>( iCurPos, 0, iFillSPos, REN_IS_HOLE, riError );
-  }
-}
-
-template <BlenMod iBM, Bool bBitInc> template<Bool bSet> __inline Void
-TRenSingleModelC<iBM,bBitInc>::xExtrapolateMarginR(Int iCurSPos, Int iCurPos, RMDist& riError )
-{
-  //  if (iLeftSPos < 0 )
-  //    return;
-
-  Int iSPosFullPel = std::min(m_iWidth-1,xRangeRightR(iCurSPos));
-
-  m_iThisDepth = m_iCurDepth;
-  if (iSPosFullPel > -1)
-  {
-    xSetShiftedPelR<bSet>( iCurPos, 1 << m_iShiftPrec, iSPosFullPel, REN_IS_FILLED, riError );
-  }
-
-  for (Int iFillSPos = iSPosFullPel -1; iFillSPos > -1; iFillSPos-- )
-  {
-    xSetShiftedPelR<bSet>( iCurPos , 1 << m_iShiftPrec, iFillSPos, REN_IS_HOLE, riError );
-  }
-}
-
-template <BlenMod iBM, Bool bBitInc> __inline Int
+  if ( xGeQ<Int,bL>(xWidthMinus1<bL>(), iSPosFullPel) )
+  {
+    xSetShiftedPel<bL, bSM>( iCurPos, bL ? 0 : (1 << m_iShiftPrec) , iSPosFullPel, REN_IS_FILLED, riError );
+  }
+  for (Int iFillSPos = xPlus<Int,bL>(iSPosFullPel ,1); xGeQ<Int,bL>( xWidthMinus1<bL>(), iFillSPos ); xInc<Int,bL>(iFillSPos))
+  {
+    xSetShiftedPel<bL, bSM>( iCurPos, bL ? 0 : ( 1 << m_iShiftPrec ), iFillSPos, REN_IS_HOLE, riError );
+  }
+}
+
+template <BlenMod iBM, Bool bBitInc> template <Bool bL> __inline Int
 TRenSingleModelC<iBM,bBitInc>::xShiftNewData( Int iPosX, Int iPosInNewData )
 {
   RM_AOT( iPosInNewData <               0 );
   RM_AOF( iPosInNewData < m_iNewDataWidth );
-
   return (iPosX << m_iShiftPrec) - m_ppiCurLUT[0][ RenModRemoveBitInc( m_piNewDepthData[iPosInNewData] )];
 }
 
+
 template <BlenMod iBM, Bool bBitInc> __inline Int
+TRenSingleModelC<iBM,bBitInc>::xShiftDept( Int iPosXinSubPel, Int iDepth )
+{
+  return (iPosXinSubPel) - m_ppiCurLUT[0][ RenModRemoveBitInc( iDepth )];
+}
+
+
+template <BlenMod iBM, Bool bBitInc> template <Bool bL> __inline Int
 TRenSingleModelC<iBM,bBitInc>::xShift( Int iPosX )
 {
  RM_AOT( iPosX <        0);
  RM_AOF( iPosX < m_iWidth);
-
- return (iPosX  << m_iShiftPrec) - m_ppiCurLUT[0][ RenModRemoveBitInc( m_pcInputSamplesRow[m_iCurViewPos][iPosX].iD )];
-}
-
-
-template <BlenMod iBM, Bool bBitInc> __inline Int
+ return (iPosX  << m_iShiftPrec) - m_ppiCurLUT[0][ RenModRemoveBitInc( m_pcInputSamplesRow[(bL ? 0 : 1)][iPosX].iD )];
+}
+
+
+template <BlenMod iBM, Bool bBitInc> template <Bool bL> __inline Int
 TRenSingleModelC<iBM,bBitInc>::xShift( Int iPos, Int iPosInNewData )
 {
@@ -1302,46 +1168,47 @@
   else
   {
-    return xShift(iPos);
-  }
-}
-
-template <BlenMod iBM, Bool bBitInc> __inline Int
-TRenSingleModelC<iBM,bBitInc>::xRangeLeftL( Int iPos )
-{
-  return  ( iPos +  (1 << m_iShiftPrec) - 1) >> m_iShiftPrec;
-}
-
-
-template <BlenMod iBM, Bool bBitInc> __inline Int
-TRenSingleModelC<iBM,bBitInc>::xRangeLeftR( Int iPos )
-{
-
-  return  xRangeRightR( iPos ) + 1;
-}
-
-
-template <BlenMod iBM, Bool bBitInc> __inline Int
-TRenSingleModelC<iBM,bBitInc>::xRangeRightL( Int iPos )
-{
-  return xRangeLeftL(iPos) - 1;
-}
-
-template <BlenMod iBM, Bool bBitInc> __inline Int
-TRenSingleModelC<iBM,bBitInc>::xRangeRightR( Int iPos )
-{
-  return iPos >> m_iShiftPrec;
-}
-
-
-template <BlenMod iBM, Bool bBitInc> __inline Int
-TRenSingleModelC<iBM,bBitInc>::xRoundL( Int iPos )
-{
-  return  (iPos + (( 1 << m_iShiftPrec ) >> 1 )) >> m_iShiftPrec;
-}
-
-template <BlenMod iBM, Bool bBitInc> __inline Int
-TRenSingleModelC<iBM,bBitInc>::xRoundR( Int iPos )
-{
-  return  (m_iShiftPrec == 0) ? iPos : xRoundL(iPos - 1);
+    return xShift<bL>(iPos);
+  }
+}
+
+template <BlenMod iBM, Bool bBitInc> template<Bool bL> __inline Int
+TRenSingleModelC<iBM,bBitInc>::xRangeLeft( Int iPos )
+{
+  if ( bL )
+  {
+    return  ( iPos +  (1 << m_iShiftPrec) - 1) >> m_iShiftPrec;
+  }
+  else
+  {
+    return iPos >> m_iShiftPrec;
+  }
+}
+
+
+
+template <BlenMod iBM, Bool bBitInc> template<Bool bL> __inline Int
+TRenSingleModelC<iBM,bBitInc>::xRangeRight( Int iPos )
+{
+  if ( bL )
+  {
+    return xRangeLeft<true>(iPos)    - 1;
+  }
+  else
+  {
+    return xRangeLeft<false>( iPos ) + 1;   
+  }  
+}
+
+template <BlenMod iBM, Bool bBitInc> template<Bool bL> __inline Int
+TRenSingleModelC<iBM,bBitInc>::xRound( Int iPos )
+{
+  if( bL )
+  {  
+    return  (iPos + (( 1 << m_iShiftPrec ) >> 1 )) >> m_iShiftPrec;
+  }
+  else
+  {
+    return  (m_iShiftPrec == 0) ? iPos : xRound<true>(iPos - 1);
+  }
 }
 
@@ -1387,6 +1254,6 @@
 }
 
-template <BlenMod iBM, Bool bBitInc> template<Bool bSet> __inline Void
-TRenSingleModelC<iBM,bBitInc>::xSetShiftedPelL(Int iSourcePos, Int iSubSourcePos, Int iTargetSPos, Pel iFilled, RMDist& riError )
+template <BlenMod iBM, Bool bBitInc> template<Bool bL, SetMod bSM> __inline Void
+TRenSingleModelC<iBM,bBitInc>::xSetShiftedPel(Int iSourcePos, Int iSubSourcePos, Int iTargetSPos, Pel iFilled, RMDist& riError )
 {
   RM_AOT( iSourcePos    <  0                   );
